#!/usr/bin/perl
use strict;
my ($noise0,$debug);
my ($noise3,$noise4,$noise5,$noise1,$noise2);
$debug=0;
$noise0=parse();
# Remove () and split
@$noise1=sort key @$noise0;
$noise2=groupfreq($noise1);
printf "END\n"if($debug);
$noise3=groupnames($noise2);
$noise4=sortnoise2($noise3);
$noise5=incrnoise($noise4);
printnoise($noise5);

sub parse {
my ($res,@out,$name);
$res=[];
LINE: while(<>){
if (/^Legend:/o) {
@out=();
VARS: while(<>)
	{
	my (@F,$var);
	last VARS if(!/^OUT_[0-9]+\b/o);
	@F=split;
		if(scalar(@F)==3){
		$var= {"outvar"=>$F[0],"name"=>$F[2]};
		push(@out,$var);
		}
	}
}
elsif(/^\W*F\b/o){
	my ($subs);
# Replace OUT* name by varname, remove ()- first
	s/[()-]//go;
	foreach $subs (@out) { s/$subs->{outvar}/$subs->{name}/g; }
	s/[()]//go;
	@$name=split;
	shift(@$name);
# Skip until non whitespace character found
	skipwhite();
	$res=subvars($res,$_,$name);
#Parse until no non whitespace character found
	PR: while(<>){
	last PR if !/\S/o;
	$res=subvars($res,$_,$name);
	};
}
}
return($res);
}

sub skipwhite {
while(<>){
last if  /\S/o;
};
}

sub subvars {
my ($res,$line,$names)=@_;
my ($freq,$j,$val,@vals);
$_=$line;
($freq,@vals)=split;
for($j=0;$val=shift(@vals);$j++){
push(@$res,{freq=>$freq,val=>$val,name=>$names->[$j]});
print "SUBVARS: FREQ=$freq, VAL=$val, NAME=$names->[$j]\n" if ($debug);
}
return($res);
}

sub sortnoise2 {
my ($noise)=@_;
my ($res);
@$res=map {my ($i);$i=$_;{freq=>$i->{freq},vals=>sortvals($i->{vals})}} @$noise;
return($res);
}
sub sortvals {
my ($vals)=@_;
my ($res);
@$res=sort {$a->{val} <=> $b->{val}} @$vals;
return($res);
}
sub key {
$a->{freq}==$b->{freq}?$a->{name} cmp $b->{name}: $a->{freq} <=> $b->{freq};
}
sub incrnoise {
my ($noise)=@_;
my ($res,$ntot);
@$res=map {my ($i);$i=$_;
	$ntot=ntotal($i->{vals});
	{freq=>$i->{freq},vals=>incrnoise1($ntot,$i->{vals})};
	} @$noise;
return($res);
}
sub incrnoise1 {
my ($ntot,$vals)=@_;
my ($frac,$nrun,$res);
$nrun=0;
@$res=map {my ($i);$i=$_;$nrun+=$i->{val};$frac=$nrun/$ntot;
		{val=>$i->{val},nincr=>$frac,name=>$i->{name}}} @$vals;
return($res);
}

sub ntotal {
my ($vals)=@_;
my ($res,$i);
$res=0;
foreach $i (@$vals){
$res+=$i->{val};
}
return($res);
}

sub printnoise {
my ($noise)=@_;
my ($i,$j);
foreach $i (@$noise){
my ($vals,$freq);
my ($val,$name,$nincr);
$vals=$i->{vals};
$freq=$i->{freq};
foreach $j (@$vals){
$name=$j->{name};
$val=$j->{val};
$nincr=$j->{nincr};
printf "%e\t%e\t%e\t%s\n",$freq,$val,$nincr,$name;
}
}
}
sub printnoise1 {
my ($noise)=@_;
my ($j,$i);
foreach $i (@$noise){
my ($val,$vals,$freq,$name);
$vals=$i->{vals};
$freq=$i->{freq};
foreach $j (@$vals){
$name=$j->{name};
$val=$j->{val};
printf "%e\t%e\t%s\n",$freq,$val,$name;
}
}
}
# groupfreq type: [freqterm]
# freqterm ==(freq:double,[val]);
# val=(val:double,name:string);
sub groupfreq {
my ($noise)=@_;
my ($head,$i,$res,$vals,$freq);
$res=[];
$vals=[];
$head=$noise->[0];
$freq=$head->{freq};
print "GROUPFREQ\n" if($debug);
print "FREQ:$freq\n" if($debug);
foreach $i (@$noise)
{
my ($val);
if($freq!=$i->{freq}) {
push(@$res,{freq=>$freq,vals=>$vals});$vals=[];$freq=$i->{freq};
print "FREQ:$freq\n" if($debug);
}
$val={val=>$i->{val},name=>$i->{name}};
push(@$vals,$val);
}
push(@$res,{freq=>$freq,vals=>$vals});
print "FREQ:$freq\n" if($debug);
return($res);
}
# input type: [freqterm]
# freqterm ==(freq:double,[val]);
# val=(val:double,name:string);
sub groupnames {
my ($noise)=@_;
my ($res);
print "GROUPNAMES:\n" if ($debug);
@$res=map {my ($i);$i=$_;
print "INPUT FREQ:$i->{freq}\n";
{freq=>$i->{freq},vals=>groupnames1($i->{vals})}
} @$noise;
if($debug){my ($i);foreach $i (@$res){print "FREQ:$i->{freq}\n";}};
return($res);
}
# Eats up vals! Copy in my assignment if this should not happen.
sub groupnames1 {
my ($vals)=@_;
my ($mp,$v1,$v2,$vtot,$merge,$res);
$merge=0;
$res=[];
$v2=shift(@$vals);
while(defined($v2)){
$v1=$v2;
if(!$merge){$vtot=0; $mp=matchpat($v1->{name});}
$vtot+=$v1->{val};
$v2=shift(@$vals);
# if still a line available to compare to, do lookahead and determine
# whether to merge the line in the next iteration.
$merge=defined($v2) && matches($mp,$v2->{name});
# save v1 result, start new comparison
push(@$res,{val=>$vtot,name=>$mp}) if(!$merge);
next if (!$debug);
printf "INITIALIZING DEVICE:%s\n",$v1->{name} if(!$merge);
printf "ADDING NOISE:%e,DEVICE:%s:TOTAL:%e\n",$v1->{val},$v1->{name},$vtot;
printf "SETTING DEVICE NAME TO:%s\n",$mp if ($merge);
printf "PUSHING:%e,DEVICE:%s\n",$vtot,$mp if(!$merge);
}
return($res);
}
sub matchpat {
local ($_)=@_;
my ($str);
$str=$_;
s/^([^.]+_)\d+(_\..*)$/$1\[0-9\]\+$2/o;
printf "STRING:%s,PATTERN:%s\n",$str,$_ if($debug);
return($_);
}
sub matches {
my ($pat,$string)=@_;
my ($res);
$_=$string;
if($pat!~/_/o){print "PATTERN $pat NOT A MULTIPLE. STRING $_. MATCH:NO\n" if($debug);return(0);}
$res=(/$pat/);
printf "STRING:%s,PATTERN:%s,MATCH:%s\n",$_,$pat,($res?"YES":"NO") if($debug);
return($res);
}
